/*
 *	opexport.h
 *
 *	This file provides most of the important OPaC reference definitions. It
 *	will be included into every other header file; this helps decreasing the
 *	cross references.
 *
 *	(C) Copyright 1994-1998, Pierre ARNAUD, OPaC bright ideas
 *		CH-1437 SUSCEVAZ, Switzerland. All rights reserved.
 */

/******************************************************************************

  This file is part of the OPaC class library ("OPaC").

  OPaC is distributed with NO WARRANTY OF ANY KIND.  No author or distributor
  accepts any responsibility for the consequences of using it, or for whether
  it serves any particular purpose or works at all, unless he or she says so
  in writing. Refer to the OPaC Free Public License (the "License") for full
  details.

  Every copy of OPaC must include a copy of the License, normally in a plain
  ASCII text file named PUBLIC. The License grants you the right to copy,
  modify and redistribute OPaC, but only under certain conditions described
  in the License. The copyright notice and this notice must be preserved on
  all copies.

******************************************************************************/

#ifndef	_OPaC_OPEXPORT_H_
#define	_OPaC_OPEXPORT_H_

#ifndef _OPaC_OBJECT_H_
#include <OPaC/object.h>
#endif

/****************************************************************/

OP_EXPORT_CLASS (OPObject);						//	root class, no superclass

/****************************************************************/

OP_EXPORT (OPAdorner, OPObject);				//	<OPaC/lookman.h>
OP_EXPORT (OPColorMan, OPObject);				//	<OPaC/grail.h>
OP_EXPORT (OPDataReport, OPObject);				//	<OPaC/datarep.h>
OP_EXPORT (OPEntity, OPObject);					//	<OPaC/database.h>
OP_EXPORT (OPEntityModel, OPObject);			//	<OPaC/database.h>
OP_EXPORT (OPEvent, OPObject);					//	<OPaC/event.h>
OP_EXPORT (OPFileBrowser, OPObject);			//	<OPaC/filebrowser.h>
OP_EXPORT (OPFontMan, OPObject);				//	<OPaC/grail.h>
OP_EXPORT (OPGenericContainer, OPObject);		//	<OPaC/container.h>
OP_EXPORT (OPGenericProvider, OPObject);		//	<OPaC/objectpane.h>
OP_EXPORT (OPGrailPath, OPObject);				//	<OPaC/grailpath.h>
OP_EXPORT (OPGrailPort, OPObject);				//	<OPaC/grail.h>
OP_EXPORT (OPGrailCursor, OPObject);			//	<OPaC/grail.h>
OP_EXPORT (OPGrailFont, OPObject);				//	<OPaC/grail.h>
OP_EXPORT (OPIterator, OPObject);				//	<OPaC/iterator.h>
OP_EXPORT (OPLookMan, OPObject);				//	<OPaC/lookman.h>
OP_EXPORT (OPPerformer, OPObject);				//	<OPaC/performer.h>
OP_EXPORT (OPRBTree, OPObject);					//	<OPaC/rbtree.h>
OP_EXPORT_CLASS (OPRuntime /* OPObject */);		//	<OPaC/object.h>
OP_EXPORT (OPSpring, OPObject);					//	<OPaC/spring.h>
OP_EXPORT (OPSpringBand, OPObject);				//	<OPaC/springboard.h>
OP_EXPORT (OPSpringBoard, OPObject);			//	<OPaC/springboard.h>
OP_EXPORT_CLASS (OPStorage /* OPObject */);		//	<OPaC/object.h>
OP_EXPORT_CLASS (OPStream /* OPObject */);		//	<OPaC/object.h>
OP_EXPORT_CLASS (OPTarget /* OPObject */);		//	<OPaC/target.h>
OP_EXPORT_CLASS (OPText /* OPObject */);		//	<OPaC/object.h>
OP_EXPORT (OPThread, OPObject);					//	<OPaC/thread.h>
OP_EXPORT (OPTime, OPObject);					//	<OPaC/time.h>
OP_EXPORT (OPTurboSearch, OPObject);			//	<OPaC/turbosrc.h>
OP_EXPORT_CLASS (OPValue /* OPObject */);		//	<OPaC/values.h>

OP_EXPORT (OPGrailPixmap, OPGrailPort);			//	<OPaC/grail.h>
OP_EXPORT (OPGrailWindow, OPGrailPixmap);		//	<OPaC/grail.h>

OP_EXPORT (OPResponder, OPObject);				//	<OPaC/view.h>

OP_EXPORT (OPView, OPResponder);				//	<OPaC/view.h>

OP_EXPORT (OPCellGrid, OPView);					//	<OPaC/cellgrid.h>
OP_EXPORT (OPControl, OPView);					//	<OPaC/view.h>
OP_EXPORT (OPDBScrollList, OPView);				//	<OPaC/dbscrlist.h>
OP_EXPORT (OPObjectBrowser, OPView);			//	<OPaC/objectbrowser.h>
OP_EXPORT (OPTabView, OPView);					//	<OPaC/tabview.h>
OP_EXPORT (OPWindow, OPView);					//	<OPaC/view.h>

OP_EXPORT (OPBoxView, OPControl);				//	<OPaC/boxview.h>
OP_EXPORT (OPButton, OPControl);				//	<OPaC/button.h>
OP_EXPORT (OPCell, OPControl);					//	<OPaC/cell.h>
OP_EXPORT (OPDragPalette, OPControl);			//	<OPaC/dragpal.h>
OP_EXPORT (OPIcon, OPControl);					//	<OPaC/icon.h>
OP_EXPORT (OPIconSet, OPControl);				//	<OPaC/iconset.h>
OP_EXPORT (OPMonitorValue, OPControl);			//	<OPaC/monitorvalue.h>
OP_EXPORT (OPObjectWell, OPControl);			//	<OPaC/objectwell.h>
OP_EXPORT (OPScroller, OPControl);				//	<OPaC/scroller.h>
OP_EXPORT (OPScrollGrid, OPControl);			//	<OPaC/scrgrid.h>
OP_EXPORT (OPScrollListPane, OPControl);		//	<OPaC/scrlistpane.h>
OP_EXPORT (OPScrollView, OPControl);			//	<OPaC/scrview.h>
OP_EXPORT (OPSelView, OPControl);				//	<OPaC/selview.h>
OP_EXPORT (OPSwitch, OPControl);				//	<OPaC/switch.h>
OP_EXPORT (OPTabList, OPControl);				//	<OPaC/tablist.h>
OP_EXPORT (OPTextLine, OPControl);				//	<OPaC/textline.h>
OP_EXPORT (OPTextTagBase, OPControl);			//	<OPaC/texttag.h>

OP_EXPORT (OPSlider, OPScroller);				//	<OPaC/slider.h>
OP_EXPORT (OPSelGrid, OPCellGrid);				//	<OPaC/selgrid.h>
OP_EXPORT (OPObjectPane, OPScrollGrid);			//	<OPaC/objectpane.h>

OP_EXPORT (OPGridList, OPSelGrid);				//	<OPaC/gridlist.h>

OP_EXPORT (OPDragView, OPWindow);				//	<OPaC/dragview.h>
OP_EXPORT (OPMenu, OPWindow);					//	<OPaC/menu.h>
OP_EXPORT (OPToolTip, OPWindow);				//	<OPaC/tooltip.h>

OP_EXPORT (OPDataView, OPMonitorValue);			//	<OPaC/dataview.h>
OP_EXPORT (OPMonitorAnalogic, OPMonitorValue);	//	<OPaC/monitorana.h>

OP_EXPORT (OPLed7Display, OPTextTagBase);		//	<OPaC/led7disp.h>
OP_EXPORT (OPTextTag, OPTextTagBase);			//	<OPaC/texttag.h>

OP_EXPORT (OPTextCaption, OPTextTag);			//	<OPaC/textcaption.h>

OP_EXPORT (OPContainer, OPGenericContainer);	//	<OPaC/container.h>
OP_EXPORT (OPDataBase, OPGenericContainer);		//	<OPaC/database.h>
OP_EXPORT (OPDataLog, OPGenericContainer);		//	<OPaC/datalog.h>
OP_EXPORT (OPDataMirror, OPGenericContainer);	//	<OPaC/datamir.h>
OP_EXPORT (OPDataSlot, OPGenericContainer);		//	<OPaC/dataslot.h>
OP_EXPORT (OPSet, OPGenericContainer);			//	<OPaC/container.h>

OP_EXPORT (OPHashTable, OPContainer);			//	<OPaC/container.h>
OP_EXPORT (OPList, OPContainer);				//	<OPaC/container.h>

OP_EXPORT (OPObjectProvider, OPGenericProvider); //	<OPaC/objectpane.h>
OP_EXPORT (OPObjBProvider, OPGenericProvider);	 //	<OPaC/objectbrowser.h>
OP_EXPORT (OPObjRootProvider, OPGenericProvider);//	<OPaC/objectbrowser.h>

OP_EXPORT (OPDBProvider, OPObjectProvider);		//	<OPaC/objectpane.h>


/***** special case for OPArray class ****/
OP_EXPORT_CLASS (OPArray);
OP_DEFINE_REF_BEGIN (OPArray, OPContainer);
	OPObjectRef& operator [] (Count pos) const;
OP_DEFINE_REF_END (OPArray, OPContainer);
/***** special case for OPArray class ****/

OP_EXPORT (OPCyclicArray, OPArray);				//	<OPaC/cycarray.h>

OP_EXPORT (OPDict, OPSet);						//	<OPaC/container.h>

OP_EXPORT (OPApp, OPDataSlot);					//	<OPaC/app.h>
OP_EXPORT (OPDialog, OPDataSlot);				//	<OPaC/dialog.h>

OP_EXPORT (OPArrayIterator, OPIterator);		//	<OPaC/arrayit.h>
OP_EXPORT (OPListIterator, OPIterator);			//	<OPaC/listit.h>

OP_EXPORT (OPArchive, OPStorage);				//	<OPaC/archive.h>
OP_EXPORT (OPCarbonCopy, OPStorage);			//	<OPaC/carbon.h>
OP_EXPORT_CLASS (OPMessage /* OPStorage */);	//	<OPaC/message.h>

OP_EXPORT (OPFileRead, OPStream);				//	<OPaC/stream.h>
OP_EXPORT (OPFileWrite, OPStream);				//	<OPaC/stream.h>
OP_EXPORT (OPPipeClient, OPStream);				//	<OPaC/pipestream.h>
OP_EXPORT (OPPipeServer, OPStream);				//	<OPaC/pipestream.h>
OP_EXPORT (OPInternet, OPStream);				//	<OPaC/internet.h>

OP_EXPORT_CLASS (OPAtom /* OPText */);			//	<OPac/atom.h>
OP_EXPORT_CLASS (OPString /* OPText */);		//	<OPac/string.h>


/****************************************************************/

OP_DEFINE_REF_BEGIN (OPMessage, OPStorage);
	const OPMessageRef& operator - () const;
	const OPMessageRef& operator - (OPAtomIn name) const;
OP_DEFINE_REF_END (OPMessage, OPStorage);

/****************************************************************/

OP_DEFINE_REF_BEGIN (OPString, OPText);
	
//	OPStringRef (OPObjectIn x);
//	OPStringRef (OPStringIn x);
//	OPStringRef (OPString* x);
	OPStringRef (OPAtomIn string);
	OPStringRef (const LatinChar* string);
	OPStringRef (const UnicodeChar* string);
	
//	OPStringRef& operator = (OPObjectIn x);
//	OPStringRef& operator = (OPStringIn x);
//	OPStringRef& operator = (OPString* x);
	OPStringRef& operator = (OPAtomIn string);
	OPStringRef& operator = (const LatinChar* string);
	OPStringRef& operator = (const UnicodeChar* string);
	
	friend Bool operator == (OPStringIn, const LatinChar*);
	friend Bool operator == (OPStringIn, const UnicodeChar*);
	
	friend Bool operator == (const LatinChar* a, OPStringIn b);
	friend Bool operator == (const UnicodeChar* a, OPStringIn b);
	
	friend Bool operator != (OPStringIn a, const LatinChar* b);
	friend Bool operator != (const LatinChar* a, OPStringIn b);
	friend Bool operator != (OPStringIn a, const UnicodeChar* b);
	friend Bool operator != (const UnicodeChar* a, OPStringIn b);
	
OP_DEFINE_REF_END (OPString, OPText);

/****************************************************************/

OP_DEFINE_REF_BEGIN (OPAtom, OPText);
	
//	OPAtomRef (OPObjectIn x);
//	OPAtomRef (OPAtomIn x);
//	OPAtomRef (OPAtom* x);
	OPAtomRef (OPStringIn string);
	OPAtomRef (const LatinChar* string);
	OPAtomRef (const UnicodeChar* string);
	
//	OPAtomRef& operator = (OPObjectIn x);
//	OPAtomRef& operator = (OPAtomIn x);
//	OPAtomRef& operator = (OPAtom* x);
	OPAtomRef& operator = (OPStringIn string);
	OPAtomRef& operator = (const LatinChar* string);
	OPAtomRef& operator = (const UnicodeChar* string);
	
	Bool operator == (OPStringIn) const;
	Bool operator == (const LatinChar*) const;
	Bool operator == (const UnicodeChar*) const;
	
	friend Bool operator == (OPStringIn a, OPAtomIn b);
	friend Bool operator == (const LatinChar* a, OPAtomIn b);
	friend Bool operator == (const UnicodeChar* a, OPAtomIn b);
	
	friend Bool operator != (OPAtomIn a, OPStringIn b);
	friend Bool operator != (OPStringIn a, OPAtomIn b);
	friend Bool operator != (OPAtomIn a, const LatinChar* b);
	friend Bool operator != (const LatinChar* a, OPAtomIn b);
	friend Bool operator != (OPAtomIn a, const UnicodeChar* b);
	friend Bool operator != (const UnicodeChar* a, OPAtomIn b);
	
OP_DEFINE_REF_END (OPAtom, OPText);

/****************************************************************/

class OP_PUBLIC OPObjectArray : public OPArrayRef
{
public:
	OPObjectRef& operator [] (Count p) const
	{ return (OPObjectRef&)(((OPArrayRef*)(this))[0][p]); }
	OPObjectArray& operator = (OPArray* a)
	{ OPObjectRef::_Set ((OPObject*)a); return *this; }
	OPObjectArray& operator = (OPArrayIn a)
	{ OPObjectRef::_Set (a); return *this; }
};

OP_DEFINE_ARRAY (OPAdorner, OPObject);				//	<OPaC/lookman.h>
OP_DEFINE_ARRAY (OPColorMan, OPObject);				//	<OPaC/grail.h>
OP_DEFINE_ARRAY (OPDataReport, OPObject);			//	<OPaC/datarep.h>
OP_DEFINE_ARRAY (OPEntity, OPObject);				//	<OPaC/database.h>
OP_DEFINE_ARRAY (OPEntityModel, OPObject);			//	<OPaC/database.h>
OP_DEFINE_ARRAY (OPEvent, OPObject);				//	<OPaC/event.h>
OP_DEFINE_ARRAY (OPFileBrowser, OPObject);			//	<OPaC/filebrowser.h>
OP_DEFINE_ARRAY (OPFontMan, OPObject);				//	<OPaC/grail.h>
OP_DEFINE_ARRAY (OPGenericContainer, OPObject);		//	<OPaC/container.h>
OP_DEFINE_ARRAY (OPGenericProvider, OPObject);		//	<OPaC/objectpane.h>
OP_DEFINE_ARRAY (OPGrailPath, OPObject);			//	<OPaC/grailpath.h>
OP_DEFINE_ARRAY (OPGrailPort, OPObject);			//	<OPaC/grail.h>
OP_DEFINE_ARRAY (OPGrailCursor, OPObject);			//	<OPaC/grail.h>
OP_DEFINE_ARRAY (OPGrailFont, OPObject);			//	<OPaC/grail.h>
OP_DEFINE_ARRAY (OPLookMan, OPObject);				//	<OPaC/lookman.h>
OP_DEFINE_ARRAY (OPRBTree, OPObject);				//	<OPaC/rbtree.h>
OP_DEFINE_ARRAY (OPResponder, OPObject);			//	<OPaC/view.h>
OP_DEFINE_ARRAY (OPRuntime, OPObject);				//	<OPaC/object.h>
OP_DEFINE_ARRAY (OPSpring, OPObject);				//	<OPaC/spring.h>
OP_DEFINE_ARRAY (OPSpringBand, OPObject);			//	<OPaC/springboard.h>
OP_DEFINE_ARRAY (OPSpringBoard, OPObject);			//	<OPaC/springboard.h>
OP_DEFINE_ARRAY (OPStorage, OPObject);				//	<OPaC/object.h>
OP_DEFINE_ARRAY (OPStream, OPObject);				//	<OPaC/object.h>
OP_DEFINE_ARRAY (OPTarget, OPObject);				//	<OPaC/object.h>
OP_DEFINE_ARRAY (OPText, OPObject);					//	<OPaC/object.h>
OP_DEFINE_ARRAY (OPThread, OPObject);				//	<OPaC/thread.h>
OP_DEFINE_ARRAY (OPTime, OPObject);					//	<OPaC/time.h>
OP_DEFINE_ARRAY (OPTurboSearch, OPObject);			//	<OPaC/turbosrc.h>
OP_DEFINE_ARRAY (OPValue, OPObject);				//	<OPaC/values.h>

OP_DEFINE_ARRAY (OPAtom, OPText);					//	<OPaC/atom.h>
OP_DEFINE_ARRAY (OPString, OPText);					//	<OPaC/string.h>

OP_DEFINE_ARRAY (OPGrailPixmap, OPGrailPort);		//	<OPaC/grail.h>
OP_DEFINE_ARRAY (OPGrailWindow, OPGrailPixmap);		//	<OPaC/grail.h>

OP_DEFINE_ARRAY (OPView, OPResponder);				//	<OPaC/view.h>

OP_DEFINE_ARRAY (OPCellGrid, OPView);				//	<OPaC/cellgrid.h>
OP_DEFINE_ARRAY (OPControl, OPView);				//	<OPaC/view.h>
OP_DEFINE_ARRAY (OPDBScrollList, OPView);			//	<OPaC/dbscrlist.h>
OP_DEFINE_ARRAY (OPObjectBrowser, OPView);			//	<OPaC/objectbrowser.h>
OP_DEFINE_ARRAY (OPTabView, OPView);				//	<OPaC/tabview.h>
OP_DEFINE_ARRAY (OPWindow, OPView);					//	<OPaC/view.h>

OP_DEFINE_ARRAY (OPBoxView, OPControl);				//	<OPaC/boxview.h>
OP_DEFINE_ARRAY (OPButton, OPControl);				//	<OPaC/button.h>
OP_DEFINE_ARRAY (OPCell, OPControl);				//	<OPaC/cell.h>
OP_DEFINE_ARRAY (OPDragPalette, OPControl);			//	<OPaC/dragpal.h>
OP_DEFINE_ARRAY (OPIcon, OPControl);				//	<OPaC/icon.h>
OP_DEFINE_ARRAY (OPIconSet, OPControl);				//	<OPaC/iconset.h>
OP_DEFINE_ARRAY (OPMonitorValue, OPControl);		//	<OPaC/monitorvalue.h>
OP_DEFINE_ARRAY (OPObjectWell, OPControl);			//	<OPaC/objectwell.h>
OP_DEFINE_ARRAY (OPScroller, OPControl);			//	<OPaC/scroller.h>
OP_DEFINE_ARRAY (OPScrollGrid, OPControl);			//	<OPaC/scrgrid.h>
OP_DEFINE_ARRAY (OPScrollListPane, OPControl);		//	<OPaC/scrlistpane.h>
OP_DEFINE_ARRAY (OPScrollView, OPControl);			//	<OPaC/scrview.h>
OP_DEFINE_ARRAY (OPSelView, OPControl);				//	<OPaC/selview.h>
OP_DEFINE_ARRAY (OPSwitch, OPControl);				//	<OPaC/switch.h>
OP_DEFINE_ARRAY (OPTabList, OPControl);				//	<OPaC/tablist.h>
OP_DEFINE_ARRAY (OPTextLine, OPControl);			//	<OPaC/textline.h>
OP_DEFINE_ARRAY (OPTextTagBase, OPControl);			//	<OPaC/texttag.h>

OP_DEFINE_ARRAY (OPSlider, OPScroller);				//	<OPaC/slider.h>
OP_DEFINE_ARRAY (OPSelGrid, OPCellGrid);			//	<OPaC/selgrid.h>
OP_DEFINE_ARRAY (OPObjectPane, OPScrollGrid);		//	<OPaC/objectpane.h>

OP_DEFINE_ARRAY (OPGridList, OPSelGrid);			//	<OPaC/gridlist.h>

OP_DEFINE_ARRAY (OPDragView, OPWindow);				//	<OPaC/dragview.h>
OP_DEFINE_ARRAY (OPMenu, OPWindow);					//	<OPaC/menu.h>
OP_DEFINE_ARRAY (OPToolTip, OPWindow);				//	<OPaC/tooltip.h>

OP_DEFINE_ARRAY (OPDataView, OPMonitorValue);		//	<OPaC/dataview.h>
OP_DEFINE_ARRAY (OPMonitorAnalogic, OPMonitorValue);//	<OPaC/monitorana.h>

OP_DEFINE_ARRAY (OPLed7Display, OPTextTagBase);		//	<OPaC/led7disp.h>
OP_DEFINE_ARRAY (OPTextTag, OPTextTagBase);			//	<OPaC/texttag.h>

OP_DEFINE_ARRAY (OPTextCaption, OPTextTag);			//	<OPaC/textcaption.h>

OP_DEFINE_ARRAY (OPContainer, OPGenericContainer);	//	<OPaC/container.h>
OP_DEFINE_ARRAY (OPDataBase, OPGenericContainer);	//	<OPaC/database.h>
OP_DEFINE_ARRAY (OPDataLog, OPGenericContainer);	//	<OPaC/datalog.h>
OP_DEFINE_ARRAY (OPDataMirror, OPGenericContainer);	//	<OPaC/datamir.h>
OP_DEFINE_ARRAY (OPDataSlot, OPGenericContainer);	//	<OPaC/dataslot.h>
OP_DEFINE_ARRAY (OPSet, OPGenericContainer);		//	<OPaC/container.h>

OP_DEFINE_ARRAY (OPArray, OPContainer);				//	<OPaC/array.h>
OP_DEFINE_ARRAY (OPHashTable, OPContainer);			//	<OPaC/container.h>
OP_DEFINE_ARRAY (OPList, OPContainer);				//	<OPaC/container.h>

OP_DEFINE_ARRAY (OPObjectProvider, OPGenericProvider);	//<OPaC/objectpane.h>
OP_DEFINE_ARRAY (OPObjBProvider, OPGenericProvider);	//	<OPaC/objectbrowser.h>
OP_DEFINE_ARRAY (OPObjRootProvider, OPGenericProvider);	//	<OPaC/objectbrowser.h>

OP_DEFINE_ARRAY (OPDBProvider, OPObjectProvider);	//	<OPaC/objectpane.h>

OP_DEFINE_ARRAY (OPCyclicArray, OPArray);			//	<OPaC/cycarray.h>

OP_DEFINE_ARRAY (OPDict, OPSet);					//	<OPaC/container.h>

OP_DEFINE_ARRAY (OPApp, OPDataSlot);				//	<OPaC/app.h>
OP_DEFINE_ARRAY (OPDialog, OPDataSlot);				//	<OPaC/dialog.h>

OP_DEFINE_ARRAY (OPCarbonCopy, OPStorage);			//	<OPaC/carbon.h>
OP_DEFINE_ARRAY (OPArchive, OPStorage);				//	<OPaC/archive.h>

OP_DEFINE_ARRAY (OPFileRead, OPStream);				//	<OPaC/stream.h>
OP_DEFINE_ARRAY (OPFileWrite, OPStream);			//	<OPaC/stream.h>
OP_DEFINE_ARRAY (OPPipeClient, OPStream);			//	<OPaC/pipestream.h>
OP_DEFINE_ARRAY (OPPipeServer, OPStream);			//	<OPaC/pipestream.h>

OP_DEFINE_ARRAY (OPInternet, OPStream);				//	<OPaC/internet.h>


#endif /* _OPaC_OPEXPORT_H_ */
