/*
 *	textcaption.h
 *
 *	
 *
 *	(C) Copyright 1994-1997, Pierre ARNAUD, OPaC bright ideas
 *		CH-1437 SUSCEVAZ, Switzerland. All rights reserved.
 */

/******************************************************************************

  This file is part of the OPaC class library ("OPaC").

  OPaC is distributed with NO WARRANTY OF ANY KIND.  No author or distributor
  accepts any responsibility for the consequences of using it, or for whether
  it serves any particular purpose or works at all, unless he or she says so
  in writing. Refer to the OPaC Free Public License (the "License") for full
  details.

  Every copy of OPaC must include a copy of the License, normally in a plain
  ASCII text file named PUBLIC. The License grants you the right to copy,
  modify and redistribute OPaC, but only under certain conditions described
  in the License. The copyright notice and this notice must be preserved on
  all copies.

******************************************************************************/

#ifndef	_OPaC_TEXTCAPTION_H_
#define	_OPaC_TEXTCAPTION_H_

#ifndef _OPaC_OPEXPORT_H_
#include <OPaC/opexport.h>
#endif

OP_INTERFACE (textcaption.h);

#ifndef _OPaC_TEXTTAG_H_
#include <OPaC/texttag.h>
#endif

/****************************************************************/

/*
 *	The Data View class will display some data in a view
 *	using the specified type, format and font.
 */

class OP_PUBLIC OPTextCaption : public OPTextTag
{
	
protected:
	Bool			draw_frame_high;			//	TRUE => draw a high rectangle
	Bool			draw_frame_low;				//	TRUE => draw a low rectangle
	
	OPColorPixel	back_color;					//	background color
	
protected:
	OPTextCaption ();
	virtual ~ OPTextCaption ();
	
	virtual void StoreInstance (OPStorageIn storage);	/* OVERRIDDEN */
	virtual void RestoreInstance (OPStorageIn storage);	/* OVERRIDDEN */
	
public:
	virtual Bool SetBackColor (OPColorPixel pixel);
	virtual OPColorPixel ReturnBackColor () const;

	//	Inherited methods :
	
	virtual void Draw (OPGrailPortIn, OPRectIn, OPDrawOp = OP_DRAW_ALL);/* OVERRIDDEN */
	
	OP_DEFINE_CLASS (OPTextCaption, OPTextTag);
};

/****************************************************************/

#endif /* _OPaC_TEXTCAPTION_H_ */
