/*
 *	datalinkdlg.h
 *
 *	Fill in a view with the information needed to establish the
 *	connections between a data source and a data target.
 *
 *	(C) Copyright 1994-1998, Pierre ARNAUD, OPaC bright ideas
 *		CH-1437 SUSCEVAZ, Switzerland. All rights reserved.
 */

/******************************************************************************

  This file is part of the OPaC class library ("OPaC").

  OPaC is distributed with NO WARRANTY OF ANY KIND.  No author or distributor
  accepts any responsibility for the consequences of using it, or for whether
  it serves any particular purpose or works at all, unless he or she says so
  in writing. Refer to the OPaC Free Public License (the "License") for full
  details.

  Every copy of OPaC must include a copy of the License, normally in a plain
  ASCII text file named PUBLIC. The License grants you the right to copy,
  modify and redistribute OPaC, but only under certain conditions described
  in the License. The copyright notice and this notice must be preserved on
  all copies.

******************************************************************************/

#ifndef _DATALINKDLG_H_
#define _DATALINKDLG_H_

#include <OPaC/opexport.h>

/****************************************************************/

APP_EXPORT_CLASS (OPDataLinkDialog);

/****************************************************************/

APP_DEFINE_REF (OPDataLinkDialog, OPView);

/****************************************************************/

class OPDataLinkDialog : public OPView
{
private:
	OPObjectRef			source;
	OPObjectRef			target;
	
	OPDBScrollListRef	source_list;
	OPDBScrollListRef	target_list;
	OPContainerRef		source_container;
	OPContainerRef		target_container;
	
protected:
	OPDataLinkDialog ();
	virtual ~ OPDataLinkDialog ();
	
public:
	virtual void Initialise (OPObjectIn src, OPObjectIn dst);
	virtual void Connect ();
	virtual void Cancel ();
	
	APP_DEFINE_CLASS (OPDataLinkDialog, OPView);
};

/****************************************************************/

#endif /* _DATALINKDLG_H_ */
